require 'erb'

module Slideshift

  module Tool

    def self.config
      @config ||= Config.new
    end

    class Config

      def initialize
        @config = {}
      end

      def read(file)
        ERB.new("<% #{File.read(file)} %>").result(binding)
      end

      def [](name)
        @config[name.to_s.to_sym]
      end

      def []=(name, value)
        @config[name.to_s.to_sym] = value
      end

      def method_missing(name, *args)
        if name =~ /=$/
          @config[name.to_s.sub('=', '').to_sym] = args.first
        else
          @config[name.to_s.to_sym] ||= self.class.new
        end
      end

      def inspect
        @config.inspect
      end

    end

  end

end