require 'erb'

module Slideshift::Tool

  class Presentation

    def initialize(dir = ".", static = '/static')
      @dir = dir
      @static = static
      @render = Render::Markdown.new(@dir)
    end

    def static(file)
      File.join(@static, file)
    end

    def load
      template = File.read(File.expand_path("../template.erb", __FILE__))
      template = File.read("#{@dir}/template.erb") if File.exists?("#{@dir}/template.erb")
      @template = ERB.new(template)
      @render.load
    end

    def render
      @template.result(binding)
    end

    protected

    def presentation
      @render.render
    end

  end

end