require 'kramdown'
require 'kramdown/parser/kramdown'
require 'pygments'


# ToDo: clean up!
class Kramdown::Parser::Slider < Kramdown::Parser::Kramdown

  def initialize(source, options)
    super
    @block_parsers.unshift(:syntax_tag)
    @block_parsers.unshift(:slide_tag)
  end

  def parse_syntax_tag
    match = /^```(\w+)\n(.*)\n```$/m.match(@src.matched)
    @src.pos += @src.matched_size
    code = Pygments.highlight(match[2], :lexer => match[1], :options => {
        :encoding => 'utf-8'
    })
    @tree.children << Element.new(:raw, code)
  end

  def parse_slide_tag
    @src.pos += @src.matched_size
    @tree.children << Element.new(:raw, '</section><section class="slide">')
  end

  define_parser(:slide_tag, /^!SLIDE\w*$/, '')
  define_parser(:syntax_tag, /^``` ?([^\r\n]+)?\r?\n(.+?)\r?\n```\r?$/m, '')

end

module Slideshift::Tool
  module Render

    class Markdown

      def initialize(dir)
        @dir = dir
      end

      def load
        file = "#{@dir}/presentation.md"
        unless File.exists?(file)
          puts "Error: Source file (#{file}) does not exists!"
          exit(1)
        end
        @source = File.read(file)
        self
      end

      def render
        Kramdown::Document.new(@source, :input => 'Slider').to_html
      end

    end

  end
end